git-quick-stats(1)

NAME
git-quick-stats - Simple and efficient way to access various stats in a git repository.

SYNOPSIS

For non-interactive mode: git-quick-stats [OPTIONS]

For interactive mode: git-quick-stats

DESCRIPTION

Any git repository contains tons of information about commits, contributors, and files. Extracting this information is not always trivial, mostly because of a gadzillion options to a gadzillion git commands. This program allows you to see detailed information about a git repository.

GENERATE OPTIONS

-h, -?, --help

    display this help text in the terminal

-T, --detailed-git-stats

    give a detailed list of git stats

-R, --git-stats-by-branch

    see detailed list of git stats by branch

-c, --changelogs

    see changelogs

-L, --changelogs-by-author

    see changelogs by author

-S, --my-daily-stats

    see your current daily stats

-V, --csv-output-by-branch

    output daily stats by branch in CSV format

-j, --json-output

    save git log as a JSON formatted file to a specified area

LIST OPTIONS

-b, --branch-tree

    show an ASCII graph of the git repo branch history

-D, --branches-by-date

    show branches by date

-C, --contributors

    see a list of everyone who contributed to the repo

-n, --new-contributors

    list everyone who made their first contribution since a specified date

-a, --commits-per-author

    displays a list of commits per author

-d, --commits-per-day

    displays a list of commits per day

-m, --commits-by-month

    displays a list of commits per month

-Y, --commits-by-year

    displays a list of commits per year

-w, --commits-by-weekday

    displays a list of commits per weekday

-W, --commits-by-author-by-weekday

    displays a list of commits per weekday by author

-o, --commits-by-hour

    displays a list of commits per hour

-A, --commits-by-author-by-hour

    displays a list of commits per hour by author

-z, --commits-by-timezone

    displays a list of commits per timezone

-Z, --commits-by-author-by-timezone

    displays a list of commits per timezone by author

--activity-calendar

    displays a calendar-style grid of commit activity per day-of-week and month for a selected author.

SUGGEST OPTIONS

-r, --suggest-reviewers

    show the best people to contact to review code

CALENDAR OPTIONS

-k, --commits-calendar-by-author outputs a visual grid of commit activity for a selected author, grouped by day-of-week (rows: Mon..Sun) and month (columns: Jan..Dec). Each cell is 3 characters wide, separated by one space.

-H, --commits-heatmap shows a heatmap of commits per day per hour for the last 30 days

ADDITIONAL USAGE
You can set _GIT_SINCE and _GIT_UNTIL to limit the git time log, example:

export _GIT_SINCE="2017-01-20"

You can set _GIT_LIMIT for limited output log, example:

export _GIT_LIMIT=20

You can set _GIT_LOG_OPTIONS for git log options, example:

export _GIT_LOG_OPTIONS="--ignore-all-space --ignore-blank-lines"

You can exclude directories or files from the stats by using pathspec, example:

export _GIT_PATHSPEC=':!pattern'

You can set _GIT_MERGE_VIEW to show merge commits with normal commits, example:

export _GIT_MERGE_VIEW="enable"

You can also set _GIT_MERGE_VIEW to only show merge commits, example:

export _GIT_MERGE_VIEW="exclusive"

You can sort contribution stats by field "name", "commits", "insertions", "deletions", or "lines" (total lines changed) and order ("asc", "desc"). e.g.: "commits-desc"

export _GIT_SORT_BY="name-asc"

You can change to the legacy color scheme by toggling the variable "_MENU_THEME" between "default" and "legacy". You can completely disable the color theme by setting the "_MENU_THEME" variable to "none", example:

export _MENU_THEME=legacy

or export _MENU_THEME=none

You can set _GIT_BRANCH to set the branch of the stats, example:

export _GIT_BRANCH="master"

You can set _GIT_IGNORE_AUTHORS to filter out specific authors, example:

export _GIT_IGNORE_AUTHORS="(author@examle.com|username)"

You can set _GIT_DAYS to set the number of days for the heatmap, example:

export _GIT_DAYS=30"

SEE ALSO
git(1)

Project homepage: https://github.com/git-quick-stats/git-quick-stats